<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Document</title>
    <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@5.1.3/dist/css/bootstrap.css">
    <style>
        td {
            border: 2px black solid;
            padding: 100px;

        }

        .esconder {
            opacity: 0;
            transition-duration: 1s;
        }

        table {
            margin: 0 auto;
        }
    </style>
</head>

<body>
    <div class="container">
        <p>Desarrolla un juego de memoria, para ello debera tener una serie de imagenes que se aran vuelta de 2 en 2. Si
            la imagen, valor, es igual, se mantendran visibles.<br>
            El juego terminara cuando todas las imagenes, valores esten visibles.</p>

        <p>Nº de intentos= <span id="intentos">0.</span> <button id="reload" class="btn-primary">Click para
                reiniciar</button></p>


        <table>
            <tr>
                <td class="esconder"></td>
                <td class="esconder"></td>
                <td class="esconder"></td>
            </tr>
            <tr>
                <td class="esconder"></td>
                <td class="esconder"></td>
                <td class="esconder"></td>
            </tr>
            <tr>
                <td class="esconder"></td>
                <td class="esconder"></td>
                <td class="esconder"></td>
            </tr>
            <tr>
                <td class="esconder"></td>
                <td class="esconder"></td>
                <td class="esconder"></td>
            </tr>
        </table>
    </div>

    <script src="https://code.jquery.com/jquery-3.6.0.min.js"></script>
    <script>
        let primerclick = true;
        let colores = ["red", "blue", "yellow", "orange", "green", "black", "red", "blue", "yellow", "orange", "green", "black"];
        let aleatorio = [];
        let puntuacion = 0;
        let intentos = 0;

        //Boton para actualizar la pagina, reiniciando la partida.
        $("#reload").click(function () {
            location.reload();
        })

        // Creo un array con dos elementos repetidos y los pongo en posiciones aleatorias en otro array.
        for (let i = 0; i < 12; i++) {
            let c = Math.floor(Math.random() * colores.length);
            //Los colores se añaden de forma aleatoria al nuevo array.
            aleatorio[i] = colores[c];
            //Los elementos se van eliminando del array original para que no se repitan mas de dos veces.
            colores.splice(c, 1);
        }

        //Uso el nuevo array con las posiciones aleatorizadas para rellenar los cuadros.
        $('td').each(function (index) {
            $(this).css({ "backgroundColor": aleatorio[index] });
        });

        $('td').click(function () {
            //Accion del primer click, agrega un id al elemento para poder compararlo mas adelante y lo muestra.
            if (primerclick == true && $(this).hasClass("esconder")) {
                $(this).removeClass("esconder");
                $(this).attr("id", "memoria");
                primerclick = false;
            }

            //Accion del segundo click, muestra el cuadro en el que se hizo el segundo click.
            if (primerclick == false && $(this).hasClass("esconder")) {
                $(this).removeClass("esconder");

                //Se compara el color del cuadro en el que se hizo el segudno click con el color del cuadro guardado con el primer click.
                if ($("#memoria").css("backgroundColor") == $(this).css("backgroundColor")) {
                    //Si los colores son iguales se quita el id del primer click y se les quita la clase esconder por lo que siempre seran visibles y ya no haran efecto mas clicks.
                    $(this).removeClass("esconder");
                    $("#memoria").removeClass("esconder");
                    $("#memoria").attr("id", "");
                    puntuacion++;
                    intentos++;
                } else {
                    //Si los colores son diferentes se vuelven a ocultar y se reinician los clicks.
                    $(this).addClass("esconder");
                    $("#memoria").addClass("esconder");
                    $("#memoria").attr("id", "");
                    intentos++;
                }
                primerclick = true;
            }
            $("#intentos").html(intentos + ".");
            if (puntuacion == 6) {
                alert(`Felicidades, has ganado! \n
                Numero de intentos: ${intentos}.`);
            }
        });



    </script>
</body>

</html>